package com.company.jmixtest.screen.testentity

import com.company.jmixtest.entity.TestEntity
import io.jmix.core.DataManager
import io.jmix.core.LoadContext
import io.jmix.ui.model.CollectionLoader
import io.jmix.ui.screen.*
import io.jmix.ui.screen.Target
import org.springframework.beans.factory.annotation.Autowired

@UiController("jt_TestEntity.browse")
@UiDescriptor("test-entity-browse.xml")
@LookupComponent("testEntitiesTable")
class TestEntityBrowse : StandardLookup<TestEntity>() {
    @Autowired
    private lateinit var testEntitiesDl: CollectionLoader<TestEntity>

    @Autowired
    private lateinit var dataManager: DataManager

    @Subscribe
    private fun onBeforeShow(event: BeforeShowEvent) {
        testEntitiesDl.setParameter("str", "test1")
        testEntitiesDl.load()
    }

    @Install(to = "testEntitiesDl", target = Target.DATA_LOADER)
    private fun testEntitiesDlLoadDelegate(loadContext: LoadContext<TestEntity>): MutableList<TestEntity> {
        loadContext.query!!.isCacheable = true

        return dataManager.loadList(loadContext)
    }

}